Description

If the validator has some condition (:if => $smt, :unless => $smt) we shouldn't mark the field as required. In this case we simply can't

tell without AJAX call because validity may depend on another field of the form. Btw there was a project translating AR validations to

javascript (client side validations) but IIRC it's discontinued. Also it was quite big thing.

Related issues:

Related to Foreman - Feature #6400: mark required fields in form Closed 06/26/2014

Related to Foreman - Bug #7560: add :required => true on host fields that hav... Closed 09/21/2014

Related to Foreman - Feature #21678: Mark required fields conditionally based... New 11/15/2017

Associated revisions

Revision 3b87444a - 09/21/2014 07:52 AM - Marek Hulán

Fixes #7450 - do not mark non-required fields

If validation is conditional we don't mark fields as required by

default. Also fixes disabling by override using :required option.

History

#1 - 09/16/2014 04:31 AM - Marek Hulán

- Related to Feature #6400: mark required fields in form added

#2 - 09/16/2014 04:32 AM - Dominic Cleal

Do you have an example field where this is wrong?  There's an override option which can be passed into the form helper to disable it, we just need to

know which field(s) require it :)

#3 - 09/16/2014 04:42 AM - Marek Hulán

I'm afraid we can just enforce required to be true. Looking to the code I see

required_mark = ' *' if is_required?(f, attr) || options[:required]

 see https://github.com/theforeman/foreman/blob/develop/app/helpers/layout_helper.rb#L153 and 

https://github.com/theforeman/foreman/blob/develop/app/helpers/layout_helper.rb#L167 for more details.

I have no existing example since it's in form I'm currently working on for bonding.

something like

<%= text_f f, :attached_to, :help_inline => _(

"Identifier of the interface to which this interface belongs, e.g. eth1") %>

 adding :required => false does not help obviously since is_required?(f, attr) is always true

#4 - 09/16/2014 04:45 AM - Dominic Cleal
https://github.com/theforeman/foreman/blob/develop/app/helpers/layout_helper.rb#L153
https://github.com/theforeman/foreman/blob/develop/app/helpers/layout_helper.rb#L167


Indeed, that should use options[:required] unless it's nil, and only then fall back to is_required.

#5 - 09/16/2014 04:51 AM - Marek Hulán

Yup, will send a PR shortly. I thought it would be also useful to make is_required? aware of conditions and if some is present, return false (probably

makes sense in most cases?). Thoughts?

#6 - 09/16/2014 04:53 AM - Dominic Cleal

Sounds good!

#7 - 09/16/2014 05:11 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Target version set to 1.7.3

- Pull request https://github.com/theforeman/foreman/pull/1766 added

- Pull request deleted ()

#8 - 09/16/2014 05:12 AM - Marek Hulán

- Assignee set to Marek Hulán

#9 - 09/21/2014 08:01 AM - Marek Hulán

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 3b87444aac04cf78e073bcb6e7f7778ef72f9c8e.

#10 - 09/22/2014 04:19 AM - Dominic Cleal

- translation missing: en.field_release set to 21

#11 - 09/22/2014 04:20 AM - Dominic Cleal

- Related to Bug #7560: add :required => true on host fields that have conditional validation if host.managed? added

#12 - 11/15/2017 02:58 PM - Marek Hulán

- Related to Feature #21678: Mark required fields conditionally based on other fields added
